import { ApiCall } from "tsrpc";
import HQJGFun, { Data } from "./fun";
import { ReqRecDpsPrize, ResRecDpsPrize } from "../../../shared/protocols/event/huangqijiuguan/PtlRecDpsPrize";
import { PlayerFun } from "../../../public/player";

export default async function (call: ApiCall<ReqRecDpsPrize, ResRecDpsPrize>) {
    let hd = await HQJGFun.HdInfo(call, call.req.hdid);

    if (!hd) {
        // 无此活动
        return call.error('', { code: -1, message: globalThis.lng.huodong_open_1 })
    }

    let data = hd.data as Data

    // 个人活动信息
    let mydata = await HQJGFun.getMydata(call, call.req.hdid);

    // 领取伤害奖励
    let prize = [];
    for (let rec of call.req.recid) {
        let con = data.bossTask.filter(x => x.id == rec)[0];

        if (mydata.bossres.recdpstask.includes(con.id)) {
            continue
        }

        if (con.need > (mydata.bossres.maxdps || 0)) {
            continue
        }

        mydata.bossres.recdpstask.push(con.id);
        prize = prize.concat(con.prize);
    }

    if (prize.length <= 0) {
        call.error("", { code: -2, message: lng.hqjgtips_27 });
    } else {
        // 发送奖励
        await PlayerFun.sendPrize(call, prize);
        // 设置领奖记录
        await HQJGFun.setMyData(call.uid, call.req.hdid, { bossres: mydata.bossres });
    }

    call.succ({ data: mydata, prize: prize })
}