import { ApiCall } from "tsrpc";
import { ReqZhaoMu, ResZhaoMu } from "../../../shared/protocols/event/huangqijiuguan/PtlZhaoMu";
import HQJGFun from "./fun";
import { PlayerFun } from "../../../public/player";
import { PublicShared } from "../../../shared/public/public";

export default async function (call: ApiCall<ReqZhaoMu, ResZhaoMu>) {
    let hd = await HQJGFun.HdInfo(call, call.req.hdid);
    if (!hd || Object.keys(hd).length <= 0) {
        // 无此活动
        return call.error('', { code: -1, message: globalThis.lng.huodong_open_1 })
    }

    let need = [{ a: hd.data.huobi.a, t: hd.data.huobi.t, n: hd.data.huobi.n * call.req.num }];

    // 检测消耗
    await PlayerFun.checkNeedIsMeet(call, need);

    let prize = [];
    let mydata = await HQJGFun.getMydata(call, call.req.hdid);

    for (let n = 1; n <= call.req.num; n++) {
        let num = mydata.zhaomu.num + n;
        let baodi = hd.data.baodi.filter(x => x.num == num);
        if (baodi.length > 0) {
            // 触发保底
            prize = prize.concat(baodi[0].prize);
        } else {
            // 常规掉落
            let temp = PublicShared.randomDropAny<{
                a: string, t: string, n: number, p: number
            }>(
                hd.data.chouka.filter(x => x.cishu <= num)
            );
            prize.push({ a: temp.a, t: temp.t, n: temp.n });
        }
        mydata.zhaomu.num = num;
    }

    // 扣除消耗
    await PlayerFun.cutNeed(call, need);
    // 发送奖励
    await PlayerFun.sendPrize(call, prize);
    // 设置抽卡数据
    await HQJGFun.setMyData(call.uid, call.req.hdid, { zhaomu: mydata.zhaomu });

    call.succ({ data: mydata, prize: prize })
}