import { ApiCall } from "tsrpc";
import { ReqZhaoMuPrizeRec, ResZhaoMuPrizeRec } from "../../../shared/protocols/event/huangqijiuguan/PtlZhaoMuPrizeRec";
import HQJGFun from "./fun";
import { PlayerFun } from "../../../public/player";

export default async function (call: ApiCall<ReqZhaoMuPrizeRec, ResZhaoMuPrizeRec>) {
    let hd = await HQJGFun.HdInfo(call, call.req.hdid);
    if (!hd || Object.keys(hd).length <= 0) {
        // 无此活动
        return call.error('', { code: -1, message: globalThis.lng.huodong_open_1 })
    }

    let prize = [];
    let mydata = await HQJGFun.getMydata(call, call.req.hdid);

    for (let rec of call.req.recid) {
        let con = hd.data.choukajiangli[rec.idx];

        if (con.num > mydata.zhaomu.num || mydata.zhaomu.prize.includes(rec.idx)) {
            continue
        }

        if (con.dlz) {
            prize.push(con.dlz[rec.sec]);
        } else {
            prize = prize.concat(con.prize);
        }

        mydata.zhaomu.prize.push(rec.idx);
    }

    if (prize.length <= 0) {
        return call.error('', { code: -2, message: globalThis.lng.hqjgtips_28 })
    }

    // 发送奖励
    await PlayerFun.sendPrize(call, prize);
    // 设置领取数据
    await HQJGFun.setMyData(call.uid, call.req.hdid, { zhaomu: mydata.zhaomu });

    call.succ({ prize: prize, data: mydata })
}