import { patchFun, patchInit } from "../patch";
import { PublicShared } from "../shared/public/public";
import { JJCFun } from "../public/jjc";

function getRankPrize(rank: number, conf?: typeof G.gc.jjc_ph['']) {
    if (!conf) {
        conf = Object.values(G.gc.jjc_ph).filter(v => rank >= v.ph[0] && rank <= v.ph[1])[0];
    }
    if (conf) {
        return [...conf.prize, { a: 'item', t: '11', n: typeof conf.rongyuprize == 'number' ? conf.rongyuprize : PublicShared.eval(conf.rongyuprize, { a: rank }) }];
    } else {
        return [];
    }
}

class Path {

    async addEmail(email, isCross = false) {
        let { prize, uid, ...e } = email;
        let lng = await G.redis.rawGet(`user:lng:${uid}`);
        let sendEmail = {
            _id: null,
            uid: uid,
            type: e.type,
            title: e.lngTitle ? (e.lngTitle[lng] || e.lngTitle['ja']) : e.title,
            content: e.lngContent ? (e.lngContent[lng] || e.lngContent['ja']) : e.content,
            createTime: e.createTime || G.time,
            contentInsertArr: e.contentInsertArr || []
        } as any;

        /**跨服邮件给sid标识*/
        // if (isCross) {
        //     sendEmail.sid = uid.split('_')[0];
        // }
        if ((prize === null || prize === void 0 ? void 0 : prize.length) > 0) {
            sendEmail.prizeData = {
                prize: email.prize,
                isGet: false
            };
        }
        if (email.g123log && Object.keys(email.g123log).length > 0)
            sendEmail.g123log = email.g123log;

        if (email.lngTitle) {
            sendEmail.lngTitle = email.lngTitle;
            sendEmail.lngContent = email.lngContent;
        }
        //太亏了！换其他清理机制，getAllEmail是性能消耗大户
        //todo.. 换其他清理机制
        // if (!isCross) {
        //     let emailList = await this.getAllEmail(uid);
        //     if (emailList.length >= 50) {
        //         emailList.sort((a, b) => {
        //             let noPrizeA = a.prizeData == undefined ? 0 : 1;
        //             let noPrizeB = b.prizeData == undefined ? 0 : 1;
        //             let getA = a.prizeData?.isGet == true ? 0 : 1;
        //             let getB = b.prizeData?.isGet == true ? 0 : 1;
        //             if (noPrizeA != noPrizeB) {
        //                 return noPrizeA - noPrizeB;
        //             } else if (getA != getB) {
        //                 return getA - getB;
        //             }
        //             return a.createTime - b.createTime;
        //         });
        //         this.removeEmail(uid, emailList[0]._id);
        //         G.server.sendMsgByUid(uid, 'msg_s2c/EmailDel', emailList[0]._id);
        //     }
        // }
        //@ts-ignore
        await G.mongodb.collection('email').insertOne({
            ttl: new Date(), ...G.mongodb.conversionIdObj(sendEmail)
        })
    }

    async sendEmail(uid: string, rank: number, prize: atn[]) {

        if (uid.indexOf('npc_') != -1) return;

        await this.addEmail({
            uid: uid,
            type: 'system',
            title: G.gc.jjc_com.email.titel,
            content: G.gc.jjc_com.email.content,
            prize: prize,
            contentInsertArr: [rank]
        });
    }
    async fun1(a: any) {
        for (let conf of Object.values(G.gc.jjc_ph)) {
            let players = await JJCFun.getRankListUid(conf.ph[0] - 1, conf.ph[1]);

            for (let index = 0; index < players.length; index++) {
                let uid = players[index];
                await this.sendEmail(uid, conf.ph[0] + index, getRankPrize(conf.ph[0] + index, conf));
                console.log("sendEmail", uid, conf.ph[0] + index)
            }
        }

        return "sucess!!!"
    }



    async run() {
        await this.fun1(1);
    }
}

async function main() {
    await patchInit()
    let patch = new Path();
    await patch.run();
    console.log("逻辑执行完成，等待退出");
    setTimeout(function () {
        console.log('结束程序');
        process.exit();
    }, 3000);
}
main();
